#ifndef _APP_H
#define _APP_H
extern void APP_Init(void);
extern void APP_Background(void);
extern void APP_Tick(void);
extern void APP_MIDI_Tick(void);
extern void APP_MIDI_NotifyPackage(mios32_midi_port_t port, mios32_midi_package_t midi_package);
extern void APP_SRIO_ServicePrepare(void);
extern void APP_SRIO_ServiceFinish(void);
extern void APP_DIN_NotifyToggle(u32 pin, u32 pin_value);
extern void APP_ENC_NotifyChange(u32 encoder, s32 incrementer);
extern void APP_AIN_NotifyChange(u32 pin, u32 pin_value);

extern u8  PageFirst;
extern u8  PageLast; //>Loop Length - END
extern u8  Page;       // Step Page, in 4/4 Mode one Page has 16 Step     
extern u16 StepPerPage; //calculate from 0 on....so 0-15 are 16 Steps that are visible on the BLM with a 4/4Beat  
extern u16 MainLoop;   //max Length of the mainloop, if you always play shorter then 256 then you should set this to shorter values!!! (sync...)
extern u8 SyncFlag;
extern u8 StepOffset;
extern u8 Loop_Length[8]; //number of pages (0 Pages 4/4 = 16steps) 
extern u8 IND[15];
extern u16 loop_step_pos[8];
extern u8 MelOmute[8];
extern u8 REC[8];


extern u8 Seq[18][256];
extern u8 SeqTic[18][256];

extern s16 MainDelay; //the main TIC-Delay

extern s16 BaseTic;  // 128th    12    Dotted 128th     18   128th Triplet     8
extern s16 Tic;  //32x12=384 tics between 2 Notes
extern s8  PpqnDivider;
extern u8  BPM;
extern s16 TicSend;
extern s16 StepSend;
extern u16 Last; //calculated Last Step

#endif /* _APP_H */
